const {Ci, Cc} = require("chrome");
self=require("self");
url=require("url");
runtime=require("runtime");
let pkcs11=Cc["@mozilla.org/security/pkcs11;1"].getService(Ci.nsIPKCS11);

exports.main = function(options, callbacks){
  var data=self.data, platform, modname="", modpath;

  console.log(options.loadReason);
  if(options.loadReason=="startup") return;

  platform=runtime.XPCOMABI.substr(0, runtime.XPCOMABI.indexOf("-"));

  if(runtime.OS=="WINNT"){
    modname="PKCS11_eHBA.dll";
  } else if(runtime.OS=="Linux"){
    if(platform=="x86") modname="libOpenPGP11_32.so";
    if(platform=="x86_64") modname="libOpenPGP11_64.so";
  }
  if(modname==""){
    console.error("platform="+runtime.OS+"."+platform+" wird von dieser Version nicht untersttzt!");
    return;
  }
  modpath=url.toFilename(data.url(modname));
  console.log(runtime.OS+"."+platform+" - PKCS#11-Treiber: "+modname);
  try { pkcs11.deleteModule("KVNO eHBA"); } catch(e){}
  try {
    pkcs11.addModule("KVNO eHBA", modpath, 0, 0);
    console.log("PKCS#11-Treiber erfolgreich installiert");
  } catch(e){
    console.error("Fehler bei Installation von PKCS#11-Treiber: "+e);
  }
};
 
exports.onUnload = function(reason){
  if(reason=="shutdown") return;
  try {
    pkcs11.deleteModule("KVNO eHBA");
    console.log("PKCS#11-Treiber erfolgreich deinstalliert");       
  } catch (e) {
    console.error("Fehler bei Deinstallation von PKCS#11-Treiber: "+e);
  }
};
